"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.contextMustBeObject = exports.loggingResolver = void 0;

var _utils = require("./utils");

/**
 * Logging resolver. Useful for debugging.
 */
var loggingResolver = function loggingResolver() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return console.log(args, 'Logging resolver'), _utils.skip;
};
/**
 * Combining resolver to error when context is no object.
 */


exports.loggingResolver = loggingResolver;

var contextMustBeObject = function contextMustBeObject(root, args, context) {
  return context instanceof Object ? _utils.skip : new Error('Some functionality requires context to be an object.');
};

exports.contextMustBeObject = contextMustBeObject;